// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentActionMirrorUpdates implements TridentActionMirrorUpdateInterface
type FakeTridentActionMirrorUpdates struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentactionmirrorupdatesResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentactionmirrorupdates"}

var tridentactionmirrorupdatesKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentActionMirrorUpdate"}

// Get takes name of the tridentActionMirrorUpdate, and returns the corresponding tridentActionMirrorUpdate object, and an error if there is any.
func (c *FakeTridentActionMirrorUpdates) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentActionMirrorUpdate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentactionmirrorupdatesResource, c.ns, name), &netappv1.TridentActionMirrorUpdate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionMirrorUpdate), err
}

// List takes label and field selectors, and returns the list of TridentActionMirrorUpdates that match those selectors.
func (c *FakeTridentActionMirrorUpdates) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentActionMirrorUpdateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentactionmirrorupdatesResource, tridentactionmirrorupdatesKind, c.ns, opts), &netappv1.TridentActionMirrorUpdateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentActionMirrorUpdateList{ListMeta: obj.(*netappv1.TridentActionMirrorUpdateList).ListMeta}
	for _, item := range obj.(*netappv1.TridentActionMirrorUpdateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentActionMirrorUpdates.
func (c *FakeTridentActionMirrorUpdates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentactionmirrorupdatesResource, c.ns, opts))

}

// Create takes the representation of a tridentActionMirrorUpdate and creates it.  Returns the server's representation of the tridentActionMirrorUpdate, and an error, if there is any.
func (c *FakeTridentActionMirrorUpdates) Create(ctx context.Context, tridentActionMirrorUpdate *netappv1.TridentActionMirrorUpdate, opts v1.CreateOptions) (result *netappv1.TridentActionMirrorUpdate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentactionmirrorupdatesResource, c.ns, tridentActionMirrorUpdate), &netappv1.TridentActionMirrorUpdate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionMirrorUpdate), err
}

// Update takes the representation of a tridentActionMirrorUpdate and updates it. Returns the server's representation of the tridentActionMirrorUpdate, and an error, if there is any.
func (c *FakeTridentActionMirrorUpdates) Update(ctx context.Context, tridentActionMirrorUpdate *netappv1.TridentActionMirrorUpdate, opts v1.UpdateOptions) (result *netappv1.TridentActionMirrorUpdate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentactionmirrorupdatesResource, c.ns, tridentActionMirrorUpdate), &netappv1.TridentActionMirrorUpdate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionMirrorUpdate), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTridentActionMirrorUpdates) UpdateStatus(ctx context.Context, tridentActionMirrorUpdate *netappv1.TridentActionMirrorUpdate, opts v1.UpdateOptions) (*netappv1.TridentActionMirrorUpdate, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tridentactionmirrorupdatesResource, "status", c.ns, tridentActionMirrorUpdate), &netappv1.TridentActionMirrorUpdate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionMirrorUpdate), err
}

// Delete takes name of the tridentActionMirrorUpdate and deletes it. Returns an error if one occurs.
func (c *FakeTridentActionMirrorUpdates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentactionmirrorupdatesResource, c.ns, name), &netappv1.TridentActionMirrorUpdate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentActionMirrorUpdates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentactionmirrorupdatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentActionMirrorUpdateList{})
	return err
}

// Patch applies the patch and returns the patched tridentActionMirrorUpdate.
func (c *FakeTridentActionMirrorUpdates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentActionMirrorUpdate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentactionmirrorupdatesResource, c.ns, name, pt, data, subresources...), &netappv1.TridentActionMirrorUpdate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionMirrorUpdate), err
}
