// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentActionSnapshotRestores implements TridentActionSnapshotRestoreInterface
type FakeTridentActionSnapshotRestores struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentactionsnapshotrestoresResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentactionsnapshotrestores"}

var tridentactionsnapshotrestoresKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentActionSnapshotRestore"}

// Get takes name of the tridentActionSnapshotRestore, and returns the corresponding tridentActionSnapshotRestore object, and an error if there is any.
func (c *FakeTridentActionSnapshotRestores) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentActionSnapshotRestore, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentactionsnapshotrestoresResource, c.ns, name), &netappv1.TridentActionSnapshotRestore{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionSnapshotRestore), err
}

// List takes label and field selectors, and returns the list of TridentActionSnapshotRestores that match those selectors.
func (c *FakeTridentActionSnapshotRestores) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentActionSnapshotRestoreList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentactionsnapshotrestoresResource, tridentactionsnapshotrestoresKind, c.ns, opts), &netappv1.TridentActionSnapshotRestoreList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentActionSnapshotRestoreList{ListMeta: obj.(*netappv1.TridentActionSnapshotRestoreList).ListMeta}
	for _, item := range obj.(*netappv1.TridentActionSnapshotRestoreList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentActionSnapshotRestores.
func (c *FakeTridentActionSnapshotRestores) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentactionsnapshotrestoresResource, c.ns, opts))

}

// Create takes the representation of a tridentActionSnapshotRestore and creates it.  Returns the server's representation of the tridentActionSnapshotRestore, and an error, if there is any.
func (c *FakeTridentActionSnapshotRestores) Create(ctx context.Context, tridentActionSnapshotRestore *netappv1.TridentActionSnapshotRestore, opts v1.CreateOptions) (result *netappv1.TridentActionSnapshotRestore, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentactionsnapshotrestoresResource, c.ns, tridentActionSnapshotRestore), &netappv1.TridentActionSnapshotRestore{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionSnapshotRestore), err
}

// Update takes the representation of a tridentActionSnapshotRestore and updates it. Returns the server's representation of the tridentActionSnapshotRestore, and an error, if there is any.
func (c *FakeTridentActionSnapshotRestores) Update(ctx context.Context, tridentActionSnapshotRestore *netappv1.TridentActionSnapshotRestore, opts v1.UpdateOptions) (result *netappv1.TridentActionSnapshotRestore, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentactionsnapshotrestoresResource, c.ns, tridentActionSnapshotRestore), &netappv1.TridentActionSnapshotRestore{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionSnapshotRestore), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTridentActionSnapshotRestores) UpdateStatus(ctx context.Context, tridentActionSnapshotRestore *netappv1.TridentActionSnapshotRestore, opts v1.UpdateOptions) (*netappv1.TridentActionSnapshotRestore, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tridentactionsnapshotrestoresResource, "status", c.ns, tridentActionSnapshotRestore), &netappv1.TridentActionSnapshotRestore{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionSnapshotRestore), err
}

// Delete takes name of the tridentActionSnapshotRestore and deletes it. Returns an error if one occurs.
func (c *FakeTridentActionSnapshotRestores) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentactionsnapshotrestoresResource, c.ns, name), &netappv1.TridentActionSnapshotRestore{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentActionSnapshotRestores) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentactionsnapshotrestoresResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentActionSnapshotRestoreList{})
	return err
}

// Patch applies the patch and returns the patched tridentActionSnapshotRestore.
func (c *FakeTridentActionSnapshotRestores) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentActionSnapshotRestore, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentactionsnapshotrestoresResource, c.ns, name, pt, data, subresources...), &netappv1.TridentActionSnapshotRestore{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentActionSnapshotRestore), err
}
