// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentBackends implements TridentBackendInterface
type FakeTridentBackends struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentbackendsResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentbackends"}

var tridentbackendsKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentBackend"}

// Get takes name of the tridentBackend, and returns the corresponding tridentBackend object, and an error if there is any.
func (c *FakeTridentBackends) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentbackendsResource, c.ns, name), &netappv1.TridentBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackend), err
}

// List takes label and field selectors, and returns the list of TridentBackends that match those selectors.
func (c *FakeTridentBackends) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentBackendList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentbackendsResource, tridentbackendsKind, c.ns, opts), &netappv1.TridentBackendList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentBackendList{ListMeta: obj.(*netappv1.TridentBackendList).ListMeta}
	for _, item := range obj.(*netappv1.TridentBackendList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentBackends.
func (c *FakeTridentBackends) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentbackendsResource, c.ns, opts))

}

// Create takes the representation of a tridentBackend and creates it.  Returns the server's representation of the tridentBackend, and an error, if there is any.
func (c *FakeTridentBackends) Create(ctx context.Context, tridentBackend *netappv1.TridentBackend, opts v1.CreateOptions) (result *netappv1.TridentBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentbackendsResource, c.ns, tridentBackend), &netappv1.TridentBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackend), err
}

// Update takes the representation of a tridentBackend and updates it. Returns the server's representation of the tridentBackend, and an error, if there is any.
func (c *FakeTridentBackends) Update(ctx context.Context, tridentBackend *netappv1.TridentBackend, opts v1.UpdateOptions) (result *netappv1.TridentBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentbackendsResource, c.ns, tridentBackend), &netappv1.TridentBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackend), err
}

// Delete takes name of the tridentBackend and deletes it. Returns an error if one occurs.
func (c *FakeTridentBackends) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentbackendsResource, c.ns, name), &netappv1.TridentBackend{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentBackends) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentbackendsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentBackendList{})
	return err
}

// Patch applies the patch and returns the patched tridentBackend.
func (c *FakeTridentBackends) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentbackendsResource, c.ns, name, pt, data, subresources...), &netappv1.TridentBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackend), err
}
