// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentBackendConfigs implements TridentBackendConfigInterface
type FakeTridentBackendConfigs struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentbackendconfigsResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentbackendconfigs"}

var tridentbackendconfigsKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentBackendConfig"}

// Get takes name of the tridentBackendConfig, and returns the corresponding tridentBackendConfig object, and an error if there is any.
func (c *FakeTridentBackendConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentBackendConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentbackendconfigsResource, c.ns, name), &netappv1.TridentBackendConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackendConfig), err
}

// List takes label and field selectors, and returns the list of TridentBackendConfigs that match those selectors.
func (c *FakeTridentBackendConfigs) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentBackendConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentbackendconfigsResource, tridentbackendconfigsKind, c.ns, opts), &netappv1.TridentBackendConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentBackendConfigList{ListMeta: obj.(*netappv1.TridentBackendConfigList).ListMeta}
	for _, item := range obj.(*netappv1.TridentBackendConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentBackendConfigs.
func (c *FakeTridentBackendConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentbackendconfigsResource, c.ns, opts))

}

// Create takes the representation of a tridentBackendConfig and creates it.  Returns the server's representation of the tridentBackendConfig, and an error, if there is any.
func (c *FakeTridentBackendConfigs) Create(ctx context.Context, tridentBackendConfig *netappv1.TridentBackendConfig, opts v1.CreateOptions) (result *netappv1.TridentBackendConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentbackendconfigsResource, c.ns, tridentBackendConfig), &netappv1.TridentBackendConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackendConfig), err
}

// Update takes the representation of a tridentBackendConfig and updates it. Returns the server's representation of the tridentBackendConfig, and an error, if there is any.
func (c *FakeTridentBackendConfigs) Update(ctx context.Context, tridentBackendConfig *netappv1.TridentBackendConfig, opts v1.UpdateOptions) (result *netappv1.TridentBackendConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentbackendconfigsResource, c.ns, tridentBackendConfig), &netappv1.TridentBackendConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackendConfig), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTridentBackendConfigs) UpdateStatus(ctx context.Context, tridentBackendConfig *netappv1.TridentBackendConfig, opts v1.UpdateOptions) (*netappv1.TridentBackendConfig, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tridentbackendconfigsResource, "status", c.ns, tridentBackendConfig), &netappv1.TridentBackendConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackendConfig), err
}

// Delete takes name of the tridentBackendConfig and deletes it. Returns an error if one occurs.
func (c *FakeTridentBackendConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentbackendconfigsResource, c.ns, name), &netappv1.TridentBackendConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentBackendConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentbackendconfigsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentBackendConfigList{})
	return err
}

// Patch applies the patch and returns the patched tridentBackendConfig.
func (c *FakeTridentBackendConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentBackendConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentbackendconfigsResource, c.ns, name, pt, data, subresources...), &netappv1.TridentBackendConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentBackendConfig), err
}
