// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentMirrorRelationships implements TridentMirrorRelationshipInterface
type FakeTridentMirrorRelationships struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentmirrorrelationshipsResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentmirrorrelationships"}

var tridentmirrorrelationshipsKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentMirrorRelationship"}

// Get takes name of the tridentMirrorRelationship, and returns the corresponding tridentMirrorRelationship object, and an error if there is any.
func (c *FakeTridentMirrorRelationships) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentMirrorRelationship, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentmirrorrelationshipsResource, c.ns, name), &netappv1.TridentMirrorRelationship{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentMirrorRelationship), err
}

// List takes label and field selectors, and returns the list of TridentMirrorRelationships that match those selectors.
func (c *FakeTridentMirrorRelationships) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentMirrorRelationshipList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentmirrorrelationshipsResource, tridentmirrorrelationshipsKind, c.ns, opts), &netappv1.TridentMirrorRelationshipList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentMirrorRelationshipList{ListMeta: obj.(*netappv1.TridentMirrorRelationshipList).ListMeta}
	for _, item := range obj.(*netappv1.TridentMirrorRelationshipList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentMirrorRelationships.
func (c *FakeTridentMirrorRelationships) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentmirrorrelationshipsResource, c.ns, opts))

}

// Create takes the representation of a tridentMirrorRelationship and creates it.  Returns the server's representation of the tridentMirrorRelationship, and an error, if there is any.
func (c *FakeTridentMirrorRelationships) Create(ctx context.Context, tridentMirrorRelationship *netappv1.TridentMirrorRelationship, opts v1.CreateOptions) (result *netappv1.TridentMirrorRelationship, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentmirrorrelationshipsResource, c.ns, tridentMirrorRelationship), &netappv1.TridentMirrorRelationship{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentMirrorRelationship), err
}

// Update takes the representation of a tridentMirrorRelationship and updates it. Returns the server's representation of the tridentMirrorRelationship, and an error, if there is any.
func (c *FakeTridentMirrorRelationships) Update(ctx context.Context, tridentMirrorRelationship *netappv1.TridentMirrorRelationship, opts v1.UpdateOptions) (result *netappv1.TridentMirrorRelationship, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentmirrorrelationshipsResource, c.ns, tridentMirrorRelationship), &netappv1.TridentMirrorRelationship{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentMirrorRelationship), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTridentMirrorRelationships) UpdateStatus(ctx context.Context, tridentMirrorRelationship *netappv1.TridentMirrorRelationship, opts v1.UpdateOptions) (*netappv1.TridentMirrorRelationship, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tridentmirrorrelationshipsResource, "status", c.ns, tridentMirrorRelationship), &netappv1.TridentMirrorRelationship{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentMirrorRelationship), err
}

// Delete takes name of the tridentMirrorRelationship and deletes it. Returns an error if one occurs.
func (c *FakeTridentMirrorRelationships) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentmirrorrelationshipsResource, c.ns, name), &netappv1.TridentMirrorRelationship{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentMirrorRelationships) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentmirrorrelationshipsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentMirrorRelationshipList{})
	return err
}

// Patch applies the patch and returns the patched tridentMirrorRelationship.
func (c *FakeTridentMirrorRelationships) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentMirrorRelationship, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentmirrorrelationshipsResource, c.ns, name, pt, data, subresources...), &netappv1.TridentMirrorRelationship{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentMirrorRelationship), err
}
