// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentTransactions implements TridentTransactionInterface
type FakeTridentTransactions struct {
	Fake *FakeTridentV1
	ns   string
}

var tridenttransactionsResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridenttransactions"}

var tridenttransactionsKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentTransaction"}

// Get takes name of the tridentTransaction, and returns the corresponding tridentTransaction object, and an error if there is any.
func (c *FakeTridentTransactions) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentTransaction, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridenttransactionsResource, c.ns, name), &netappv1.TridentTransaction{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentTransaction), err
}

// List takes label and field selectors, and returns the list of TridentTransactions that match those selectors.
func (c *FakeTridentTransactions) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentTransactionList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridenttransactionsResource, tridenttransactionsKind, c.ns, opts), &netappv1.TridentTransactionList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentTransactionList{ListMeta: obj.(*netappv1.TridentTransactionList).ListMeta}
	for _, item := range obj.(*netappv1.TridentTransactionList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentTransactions.
func (c *FakeTridentTransactions) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridenttransactionsResource, c.ns, opts))

}

// Create takes the representation of a tridentTransaction and creates it.  Returns the server's representation of the tridentTransaction, and an error, if there is any.
func (c *FakeTridentTransactions) Create(ctx context.Context, tridentTransaction *netappv1.TridentTransaction, opts v1.CreateOptions) (result *netappv1.TridentTransaction, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridenttransactionsResource, c.ns, tridentTransaction), &netappv1.TridentTransaction{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentTransaction), err
}

// Update takes the representation of a tridentTransaction and updates it. Returns the server's representation of the tridentTransaction, and an error, if there is any.
func (c *FakeTridentTransactions) Update(ctx context.Context, tridentTransaction *netappv1.TridentTransaction, opts v1.UpdateOptions) (result *netappv1.TridentTransaction, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridenttransactionsResource, c.ns, tridentTransaction), &netappv1.TridentTransaction{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentTransaction), err
}

// Delete takes name of the tridentTransaction and deletes it. Returns an error if one occurs.
func (c *FakeTridentTransactions) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridenttransactionsResource, c.ns, name), &netappv1.TridentTransaction{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentTransactions) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridenttransactionsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentTransactionList{})
	return err
}

// Patch applies the patch and returns the patched tridentTransaction.
func (c *FakeTridentTransactions) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentTransaction, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridenttransactionsResource, c.ns, name, pt, data, subresources...), &netappv1.TridentTransaction{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentTransaction), err
}
