// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentVolumePublications implements TridentVolumePublicationInterface
type FakeTridentVolumePublications struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentvolumepublicationsResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentvolumepublications"}

var tridentvolumepublicationsKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentVolumePublication"}

// Get takes name of the tridentVolumePublication, and returns the corresponding tridentVolumePublication object, and an error if there is any.
func (c *FakeTridentVolumePublications) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentVolumePublication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentvolumepublicationsResource, c.ns, name), &netappv1.TridentVolumePublication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumePublication), err
}

// List takes label and field selectors, and returns the list of TridentVolumePublications that match those selectors.
func (c *FakeTridentVolumePublications) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentVolumePublicationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentvolumepublicationsResource, tridentvolumepublicationsKind, c.ns, opts), &netappv1.TridentVolumePublicationList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentVolumePublicationList{ListMeta: obj.(*netappv1.TridentVolumePublicationList).ListMeta}
	for _, item := range obj.(*netappv1.TridentVolumePublicationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentVolumePublications.
func (c *FakeTridentVolumePublications) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentvolumepublicationsResource, c.ns, opts))

}

// Create takes the representation of a tridentVolumePublication and creates it.  Returns the server's representation of the tridentVolumePublication, and an error, if there is any.
func (c *FakeTridentVolumePublications) Create(ctx context.Context, tridentVolumePublication *netappv1.TridentVolumePublication, opts v1.CreateOptions) (result *netappv1.TridentVolumePublication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentvolumepublicationsResource, c.ns, tridentVolumePublication), &netappv1.TridentVolumePublication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumePublication), err
}

// Update takes the representation of a tridentVolumePublication and updates it. Returns the server's representation of the tridentVolumePublication, and an error, if there is any.
func (c *FakeTridentVolumePublications) Update(ctx context.Context, tridentVolumePublication *netappv1.TridentVolumePublication, opts v1.UpdateOptions) (result *netappv1.TridentVolumePublication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentvolumepublicationsResource, c.ns, tridentVolumePublication), &netappv1.TridentVolumePublication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumePublication), err
}

// Delete takes name of the tridentVolumePublication and deletes it. Returns an error if one occurs.
func (c *FakeTridentVolumePublications) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentvolumepublicationsResource, c.ns, name), &netappv1.TridentVolumePublication{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentVolumePublications) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentvolumepublicationsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentVolumePublicationList{})
	return err
}

// Patch applies the patch and returns the patched tridentVolumePublication.
func (c *FakeTridentVolumePublications) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentVolumePublication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentvolumepublicationsResource, c.ns, name, pt, data, subresources...), &netappv1.TridentVolumePublication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumePublication), err
}
