// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	netappv1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTridentVolumeReferences implements TridentVolumeReferenceInterface
type FakeTridentVolumeReferences struct {
	Fake *FakeTridentV1
	ns   string
}

var tridentvolumereferencesResource = schema.GroupVersionResource{Group: "trident.netapp.io", Version: "v1", Resource: "tridentvolumereferences"}

var tridentvolumereferencesKind = schema.GroupVersionKind{Group: "trident.netapp.io", Version: "v1", Kind: "TridentVolumeReference"}

// Get takes name of the tridentVolumeReference, and returns the corresponding tridentVolumeReference object, and an error if there is any.
func (c *FakeTridentVolumeReferences) Get(ctx context.Context, name string, options v1.GetOptions) (result *netappv1.TridentVolumeReference, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tridentvolumereferencesResource, c.ns, name), &netappv1.TridentVolumeReference{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumeReference), err
}

// List takes label and field selectors, and returns the list of TridentVolumeReferences that match those selectors.
func (c *FakeTridentVolumeReferences) List(ctx context.Context, opts v1.ListOptions) (result *netappv1.TridentVolumeReferenceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tridentvolumereferencesResource, tridentvolumereferencesKind, c.ns, opts), &netappv1.TridentVolumeReferenceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &netappv1.TridentVolumeReferenceList{ListMeta: obj.(*netappv1.TridentVolumeReferenceList).ListMeta}
	for _, item := range obj.(*netappv1.TridentVolumeReferenceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tridentVolumeReferences.
func (c *FakeTridentVolumeReferences) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tridentvolumereferencesResource, c.ns, opts))

}

// Create takes the representation of a tridentVolumeReference and creates it.  Returns the server's representation of the tridentVolumeReference, and an error, if there is any.
func (c *FakeTridentVolumeReferences) Create(ctx context.Context, tridentVolumeReference *netappv1.TridentVolumeReference, opts v1.CreateOptions) (result *netappv1.TridentVolumeReference, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tridentvolumereferencesResource, c.ns, tridentVolumeReference), &netappv1.TridentVolumeReference{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumeReference), err
}

// Update takes the representation of a tridentVolumeReference and updates it. Returns the server's representation of the tridentVolumeReference, and an error, if there is any.
func (c *FakeTridentVolumeReferences) Update(ctx context.Context, tridentVolumeReference *netappv1.TridentVolumeReference, opts v1.UpdateOptions) (result *netappv1.TridentVolumeReference, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tridentvolumereferencesResource, c.ns, tridentVolumeReference), &netappv1.TridentVolumeReference{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumeReference), err
}

// Delete takes name of the tridentVolumeReference and deletes it. Returns an error if one occurs.
func (c *FakeTridentVolumeReferences) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tridentvolumereferencesResource, c.ns, name), &netappv1.TridentVolumeReference{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTridentVolumeReferences) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tridentvolumereferencesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &netappv1.TridentVolumeReferenceList{})
	return err
}

// Patch applies the patch and returns the patched tridentVolumeReference.
func (c *FakeTridentVolumeReferences) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *netappv1.TridentVolumeReference, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tridentvolumereferencesResource, c.ns, name, pt, data, subresources...), &netappv1.TridentVolumeReference{})

	if obj == nil {
		return nil, err
	}
	return obj.(*netappv1.TridentVolumeReference), err
}
