// Copyright 2023 NetApp, Inc. All Rights Reserved.

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/netapp/trident/persistent_store/crd/apis/netapp/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TridentStorageClassLister helps list TridentStorageClasses.
type TridentStorageClassLister interface {
	// List lists all TridentStorageClasses in the indexer.
	List(selector labels.Selector) (ret []*v1.TridentStorageClass, err error)
	// TridentStorageClasses returns an object that can list and get TridentStorageClasses.
	TridentStorageClasses(namespace string) TridentStorageClassNamespaceLister
	TridentStorageClassListerExpansion
}

// tridentStorageClassLister implements the TridentStorageClassLister interface.
type tridentStorageClassLister struct {
	indexer cache.Indexer
}

// NewTridentStorageClassLister returns a new TridentStorageClassLister.
func NewTridentStorageClassLister(indexer cache.Indexer) TridentStorageClassLister {
	return &tridentStorageClassLister{indexer: indexer}
}

// List lists all TridentStorageClasses in the indexer.
func (s *tridentStorageClassLister) List(selector labels.Selector) (ret []*v1.TridentStorageClass, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.TridentStorageClass))
	})
	return ret, err
}

// TridentStorageClasses returns an object that can list and get TridentStorageClasses.
func (s *tridentStorageClassLister) TridentStorageClasses(namespace string) TridentStorageClassNamespaceLister {
	return tridentStorageClassNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TridentStorageClassNamespaceLister helps list and get TridentStorageClasses.
type TridentStorageClassNamespaceLister interface {
	// List lists all TridentStorageClasses in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.TridentStorageClass, err error)
	// Get retrieves the TridentStorageClass from the indexer for a given namespace and name.
	Get(name string) (*v1.TridentStorageClass, error)
	TridentStorageClassNamespaceListerExpansion
}

// tridentStorageClassNamespaceLister implements the TridentStorageClassNamespaceLister
// interface.
type tridentStorageClassNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TridentStorageClasses in the indexer for a given namespace.
func (s tridentStorageClassNamespaceLister) List(selector labels.Selector) (ret []*v1.TridentStorageClass, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.TridentStorageClass))
	})
	return ret, err
}

// Get retrieves the TridentStorageClass from the indexer for a given namespace and name.
func (s tridentStorageClassNamespaceLister) Get(name string) (*v1.TridentStorageClass, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("tridentstorageclass"), name)
	}
	return obj.(*v1.TridentStorageClass), nil
}
